Name:           virt-who
Version:        0.14
Release:        9%{?dist}
Summary:        Agent for reporting virtual guest IDs to subscription-manager

License:        GPLv2+
URL:            https://fedorahosted.org/virt-who/
Source0:        https://fedorahosted.org/releases/v/i/virt-who/%{name}-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python2-devel
Requires:       libvirt-python
# python-rhsm 1.10.10 has support for sending additional information together with guest uuids
Requires:       python-rhsm >= 1.10.10
# python-suds is required for vSphere support
Requires:       python-suds
# m2crypto is required for Hyper-V support
Requires:       m2crypto
# for journal logging
Requires:       systemd-python
# systemd stuff
BuildRequires:  systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

# systemd support
Patch0:         virt-who-0.14-systemd.patch
# logging using journal
Patch1:         virt-who-0.11-journal-logging.patch
# format debug message in print mode
Patch2:         virt-who-0.14-format-debug-message-in-print-mode.patch
# support asynchronous API in candlepin
Patch3:         virt-who-0.14-support-async-reporting.patch
# nicely order keys in debug report
Patch4:         virt-who-0.14-nicely-order-keys-in-debug-report.patch
# retry sending data multiple times
Patch5:         virt-who-0.14-retry-sending-data-multiple-times.patch
# Put uuid before guests in print mode for better readibility
Patch6:         virt-who-0.14-print-mode-item-order.patch
# Fix decoding saved association in fake mode
Patch7:         virt-who-0.14-fix-decoding-association-in-fake-mode.patch
# Stop the main loop when fatal error occurs
Patch8:         virt-who-0.14-stop-main-loop-on-fatal-error.patch
# Deprecate -b option and VIRTWHO_BACKGROUND env var
Patch9:         virt-who-0.14-deprecate-background-option.patch
# Support hypervisor_id=hostname in remote libvirt
Patch10:        virt-who-0.14-hypervisor_id-hostname-in-remote-libvirt.patch
# Fix host uuid filtering
Patch11:        virt-who-0.14-fix-host-uuid-filtering.patch
# Readd support for hypervisorType guest attribute
Patch12:        virt-who-0.14-readd-hypervisorType-attribute.patch
# Hyper-V: add proxy support
Patch13:        virt-who-0.14-hyperv-proxy-support.patch
# Set active attribute to 1 when guest is suspended
Patch14:        virt-who-0.14-set-active-1-when-suspended.patch
# hyperv: consider Quiesce EnabledState as paused state
Patch15:        virt-who-0.14-hyperv-quiesce-state-as-paused.patch
# Remove -b option completely
Patch16:        virt-who-0.14-remove-b-option.patch
# Fake: fix non-hypervisor reporting
Patch17:        virt-who-0.14-fake-fix-nonhypervisor-reporting.patch
# Use systemd notify for service status updates
Patch18:        virt-who-0.14-use-systemd-notify.patch
# Add template configuration file
Patch19:        virt-who-0.14-config-file-template.patch
# Allow single quotes and spaces in config lists
Patch20:        virt-who-0.14-single-quotes-and-space-in-config.patch
# Fail if no owner or env is set in SAM mode
Patch21:        virt-who-0.14-fail-without-owner-or-env-config.patch
# Clear obsolete reports before sending them
Patch22:        virt-who-0.14-clear-obsolete-reports.patch
# virt: don't enqueue error reports when no error occurs
Patch23:        virt-who-0.14-dont-enqueue-error-reports-without-error.patch
# Config: show warning when unapplicable option is used
Patch24:        virt-who-0.14-warn-on-unapplicable-option.patch
# fake: check if fake data are correct
Patch25:        virt-who-0.14-check-if-fake-data-are-correct.patch
# Add a warning that password auth is not supported on remote libvirt
Patch26:        virt-who-0.14-libvirt-password-unsupported-warning.patch
# Fix logging of fatal errors
Patch27:        virt-who-0.14-fix-fatal-error-logging.patch
# Warn about usage of env and owner in non-remote libvirt mode
Patch28:        virt-who-0.14-warn-about-env-and-owner-in-libvirt-mode.patch
# Fix proxy support in hyperv mode
Patch29:        virt-who-0.14-fix-hyperv-proxy-support.patch
# Don't use http_proxy for https connection and vice versa
Patch30:        virt-who-0.14-dont-use-http-proxy-for-https-connection.patch
# Check config option
Patch31:        virt-who-0.14-config-options-checking.patch
# Another attempt on hyperv proxy support
Patch32:        virt-who-0.14-hyperv-another-attempt-on-proxy-support.patch

%description
Agent that collects information about virtual guests present in the system and
report them to the subscription manager.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1

%build


%install
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p %{buildroot}/%{_sharedstatedir}/%{name}
mkdir -p %{buildroot}/%{_sysconfdir}/virt-who.d
touch %{buildroot}/%{_sharedstatedir}/%{name}/key

# Don't run test suite in check section, because it need the system to be
# registered to subscription-manager server


%post
%systemd_post virt-who.service

%preun
%systemd_preun virt-who.service

%postun
%systemd_postun_with_restart virt-who.service

%files
%doc README README.hyperv LICENSE
%{_bindir}/virt-who
%{_bindir}/virt-who-password
%{_datadir}/virt-who/
%{_unitdir}/virt-who.service
%attr(700, root, root) %dir %{_sysconfdir}/virt-who.d
%{_sysconfdir}/virt-who.d/template.conf
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/sysconfig/virt-who
%{_mandir}/man8/virt-who.8.gz
%{_mandir}/man8/virt-who-password.8.gz
%{_mandir}/man5/virt-who-config.5.gz
%attr(700, root, root) %{_sharedstatedir}/%{name}
%ghost %{_sharedstatedir}/%{name}/key


%changelog
* Tue Sep 22 2015 Radek Novacek <rnovacek@redhat.com> 0.14-9
- Check config option
- Another attempt on hyperv proxy support
- Resolves: rhbz#1254843, rhbz#1250782

* Tue Sep 15 2015 Radek Novacek <rnovacek@redhat.com> 0.14-8
- Fix logging of fatal errors
- Change systemd unit type to notify
- Warn about usage of env and owner in non-remote libvirt mode
- Fix proxy support in ESX and Hyper-V modes
- Resolves: rhbz#1254843, rhbz#1243341, rhbz#1250782

* Tue Sep 01 2015 Radek Novacek <rnovacek@redhat.com> 0.14-7
- Add a warning that password auth is not supported on remote libvirt
- Resolves: rhbz#1258726

* Thu Aug 27 2015 Radek Novacek <rnovacek@redhat.com> 0.14-6
- virt: don't enqueue error reports when no error occurs
- Config: show warning when unapplicable option is used
- fake: check if fake data are correct
- Resolves: rhbz#1257073

* Tue Aug 25 2015 Radek Novacek <rnovacek@redhat.com> 0.14-5
- Use systemd notify for service status updates
- Add template configuration file
- Allow single quotes and spaces in config lists
- Fail if no owner or env is set in SAM mode
- Clear obsolete reports before sending them
- Resolves: rhbz#1243341, rhbz#1250159, rhbz#1254840

* Tue Aug 18 2015 Radek Novacek <rnovacek@redhat.com> 0.14-4
- Readd support for hypervisorType guest attribute
- hyperv: add proxy support
- Set active attribute to 1 when guest is suspended
- hyperv: consider Quiesce EnabledState as paused state
- Remove -b option completely
- Fake: fix non-hypervisor reporting
- Resolves: rhbz#1248360

* Thu Jul 30 2015 Radek Novacek <rnovacek@redhat.com> 0.14-3
- Put uuid before guests in print mode for better readibility
- Fix decoding saved association in fake mode
- Stop the main loop when fatal error occurs
- Deprecate -b option and VIRTWHO_BACKGROUND env var
- Support hypervisor_id=hostname in remote libvirt
- Fix host uuid filtering
- Resolves: rhbz#1243683, rhbz#1167238, rhbz#1247066, rhbz#1247031, rhbz#1246409, rhbz#1246951, rhbz#1247922, rhbz#1247922, rhbz#1248425

* Thu Jul 16 2015 Radek Novacek <rnovacek@redhat.com> 0.14-2
- Support asynchronous API in candlepin
- Nicely order keys in debug report
- Retry sending data multiple times
- Resolves: rhbz#1240728, rhbz#1243697 

* Tue Jun 23 2015 Radek Novacek <rnovacek@redhat.com> 0.14-1
- Rebase to virt-who-0.14
- Resolves: rhbz#1200374

* Fri Nov 28 2014 Radek Novacek <rnovacek@redhat.com> 0.11-5
- Limit systemd service shutdown to 5 seconds
- Fix error in domain sorting
- Satellite: use proper hypervisor type in VM name
- Resolves: rhbz#1161434, rhbz#1168111, rhbz#1168122

* Thu Nov 13 2014 Radek Novacek <rnovacek@redhat.com> 0.11-4
- Fix ecrypted passwords
- Remove syslog.target from systemd unit After definition
- Fix missing config attribute of the Esx object
- Resolves: rhbz#1161607, rhbz#1162049, rhbz#1163021

* Wed Nov 05 2014 Radek Novacek <rnovacek@redhat.com> 0.11-3
- Treat remove libvirt as hypervisor
- Set /etc/sysconfig/virt-who permissions to 600
- Create /etc/virt-who.d directory
- Fix wrong options used when connecting to satellite
- Display found configurations and their modes in the log file
- Resolves: rhbz#1127965, rhbz#1158759, rhbz#1159187, rhbz#1158859, rhbz#1158803

* Tue Oct 14 2014 Radek Novacek <rnovacek@redhat.com> 0.11-2
- Add support for remote libvirt connections
- Resolves: rhbz#1127965

* Mon Sep 08 2014 Radek Novacek <rnovacek@redhat.com> 0.11-1
- Rebase to 0.11
- Resolves: rhbz#1122489

* Fri Jan 10 2014 Radek Novacek <rnovacek@redhat.com> 0.8-12
- Support sending additional information together with guest uuid on libvirt
- Reconnect to vsphere before each scan
- Requires python-rhsm >= 1.10.10
- Resolves: rhbz#1048954, rhbz#1047245

* Fri Dec 27 2013 Daniel Mach <dmach@redhat.com> - 0.8-11
- Mass rebuild 2013-12-27

* Wed Dec 11 2013 Radek Novacek <rnovacek@redhat.com> 0.8-10
- Force using background mode when starting from systemd
- Check if process defined by PID file exists
- vsphere: reconnect before each scan
- Resolves: rhbz#1036561, rhbz#1035604, rhbz#1035957

* Thu Nov 21 2013 Radek Novacek <rnovacek@redhat.com> 0.8-9
- Add satellite support
- Handle more than 100 objects in esx traversal
- Use instanceUuid when uuid of virtual machine is empty
- Resolves: rhbz#1032596

* Fri Jun 14 2013 Radek Novacek <rnovacek@redhat.com> 0.8-8
- Increase ESXi compatibility
- Resolves: rhbz#923760

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Nov 27 2012 Radek Novacek <rnovacek@redhat.com> 0.8-6
- Add systemd support
- specfile cleanup

* Thu Oct 25 2012 Radek Novacek <rnovacek@redhat.com> 0.8-5
- Fix adding https:// to ESX url

* Wed Oct 24 2012 Radek Novacek <rnovacek@redhat.com> 0.8-4
- Help and manpage improvements

* Wed Oct 17 2012 Radek Novacek <rnovacek@redhat.com> 0.8-3
- Fix bugs in Hyper-V support (patch rebased)
- Create PID file ASAP to prevent service stop fails

* Thu Oct 11 2012 Radek Novacek <rnovacek@redhat.com> 0.8-2
- Add support for accessing Hyper-V

* Wed Sep 26 2012 Radek Novacek <rnovacek@redhat.com> 0.8-1
- Upstream version 0.8
- RFE: command line improvements
- Add support for accessing RHEV-M
- Fix printing tracebacks on terminal

* Thu Apr 26 2012 Radek Novacek <rnovacek@redhat.com> 0.6-6
- Handle unknown libvirt event properly

* Wed Apr 18 2012 Radek Novacek <rnovacek@redhat.com> 0.6-5
- Enable debug output to be written to stderr
- Log guest list to log even in non-debug mode

* Tue Apr 17 2012 Radek Novacek <rnovacek@redhat.com> 0.6-4
- Fix regression in double fork patch

* Wed Mar 28 2012 Radek Novacek <rnovacek@redhat.com> 0.6-3
- Do double fork when daemon is starting

* Fri Mar 09 2012 Radek Novacek <rnovacek@redhat.com> 0.6-2
- Add python-suds require
- Requires python-rhsm >= 0.98.6

* Thu Mar 01 2012 Radek Novacek <rnovacek@redhat.com> 0.6-1
- Rebase to virt-who-0.6

* Wed Oct 12 2011 Radek Novacek <rnovacek@redhat.com> 0.3-3
- Use updateConsumer API instead of updateConsumerFact (fixes limit 255 chars of uuid list)
- Requires python-rhsm >= 0.96.13 

* Wed Sep 07 2011 Radek Novacek <rnovacek@redhat.com> - 0.3-2
- Add upstream patch that prevents failure when server not implements /status/ command

* Thu Sep 01 2011 Radek Novacek <rnovacek@redhat.com> - 0.3-1
- Add initscript and configuration file

* Mon Aug 22 2011 Radek Novacek <rnovacek@redhat.com> - 0.2-2
- Bump release because of tagging in wrong branch

* Mon Aug 22 2011 Radek Novacek <rnovacek@redhat.com> - 0.2-1
- Update to upstream version 0.2
- Add Requires: libvirt

* Fri Aug 19 2011 Radek Novacek <rnovacek@redhat.com> - 0.1-2
- Add BuildRoot tag (the package will be in RHEL5)

* Wed Aug 10 2011 Radek Novacek <rnovacek@redhat.com> - 0.1-1
- initial import
